require 'robot/simulator'

module Robot
  module Simulator
    # Controller of the game, initialize the game and receive commands from UI
    class Controller
      attr_reader :robot

      def initialize
        @robot = Robot.new Table.new(5, 5)
      end

      def place(x, y, facing)
        raise "Invalid PLACE command: PLACE #{x},#{y},#{facing}" unless robot.place Coordinate.new(x, y), Direction.from_str(facing)
      end

      def move
        raise "Invalid MOVE command: robot is not on the table or could fall if move" unless robot.move
      end

      def left
        raise "Invalid LEFT command: robot is not on the table" unless robot.turn_left
      end

      def right
        raise "Invalid RIGHT command: robot is not on the table" unless robot.turn_right
      end

      def report
        [robot.current_track.coordinate.x, robot.current_track.coordinate.y, Direction.to_str(robot.current_track.facing)] if robot.current_track
      end
    end
  end
end
