module Robot
  module Simulator
    # Table with dimension, in which a robot can be placed and roam around.
    class Table
      attr_reader :dimensionX, :dimensionY

      def initialize(dimensionX, dimensionY)
        @dimensionX, @dimensionY = dimensionX, dimensionY
      end

      def is_valid_coordinate?(coordinate)
        coordinate and
        coordinate.x >= 0 and coordinate.x < dimensionX and
        coordinate.y >= 0 and coordinate.y < dimensionY
      end
    end
  end
end
